\documentclass{article}
\usepackage[cp1251]{inputenc}
\usepackage[russian]{babel}
\usepackage[T2A]{fontenc}
\usepackage{indentfirst}
\usepackage{alltt}
\renewcommand{\topfraction}{1}
\newcommand{\ignore}[1]{{\color{green}{#1}}}
\newenvironment{code}{\begin{alltt}}{\end{alltt}}
\newenvironment{semicode}{\begin{alltt}}{\end{alltt}}
\newcommand{\prg}[1]{{\ttfamily{#1}}}
\newcommand{\FF}{\vfill\vspace*{0.000000001in}\pagebreak[4]}
 
%  :    60.  .

\title{: \prg{Tasks2.lhs}~---   ,     <<Haskell    >> (  )}

\author{  \\
 789\\
  \\
.~.~.~}

\begin{document}

\maketitle

\section{}

  (\prg{Tasks2.lhs})   Haskell-    ,     <<Haskell    >>.

       ,       , :
\begin{code}
import Hugs.Prelude
import List
import Char 
\end{code}
 ,      ,    :
\begin{code}
import Types2
\end{code}

      :
\begin{code}
import Checkit2
\end{code}

\input{Types2.lhs}

\section{    }

        :
%    -  (1)   ; (2)       -,   ,  ,     ; (3)          --     .
\begin{code}
main :: IO ()
main = do
          --   << >>
{-
-}
          chk_4_1   inRng         --    4-1
          chk_4_2   upAlpha       --    4-2
          chk_4_3   sumDigits     --    4-3
          chk_4_4   idxs          --    4-4
          chk_4_5   delGt         --    4-5
          chk_4_6   remdumps      --    4-6
          chk_4_7   chkDups       --    4-7
          chk_4_8   sumSq         --    4-8
          chk_4_9   isSorted      --    4-9
          chk_4_10  insWord       --   4-10
          chk_4_11  insWords      --   4-11
          chk_4_12  substrings    --   4-12
          chk_4_13  eApr          --   4-13
          chk_4_14  pairs         --   4-14
          chk_4_15  qs            --   4-15
          chk_4_16  fsearch       --   4-16
          chk_4_17  sqrtH         --   4-17
          chk_4_18  isPermutation --   4-18

          --   

          chk_4_19  pmatch        --   4-19

          --  << >>

          chk_4_20  hanoiSteps    --   4-20
          chk_4_21  hanoiNum     --   4-21

          -- Poly:    
          chk_4_22  eqPP          --   4-22
          chk_4_23  addPP         --   4-23
          chk_4_24  subPP         --   4-24
          chk_4_25  mulPP         --   4-25
          chk_4_26  divModPP      --   4-26
          chk_4_27  valPX         --   4-27
          chk_4_28  mulCP         --   4-28
          chk_4_29  povPN         --   4-29
          chk_4_30  dPdX          --   4-30
          chk_4_31  dNPdXN        --   4-31

          -- Poly':    

          chk_4_32  sim'P         --   4-32
          chk_4_33  eq'PP         --   4-33
          chk_4_34  add'PP        --   4-34
          chk_4_35  sub'PP        --   4-35
          chk_4_36  mul'PP        --   4-36
          chk_4_37  divMod'PP     --   4-37
          chk_4_38  val'PX        --   4-38
          chk_4_39  mul'CP        --   4-39
          chk_4_40  pov'PN        --   4-40
          chk_4_41  dP'dX         --   4-41
          chk_4_42  dNP'dXN       --   4-42

          -- Point2D:    

          -- chk_4_43  dist2D        --   4-43
          -- chk_4_44  dist2Ds       --   4-44
          -- chk_4_45  minDist2Ds    --   4-45

          -- Prop:   

          -- chk_4_46  vars          --   4-46
          -- chk_4_47  evalPV        --   4-47
          -- chk_4_48  tauto         --   4-48
          -- chk_4_49  contra        --   4-49

          -- Expr:  
          -- chk_4_50  evalEV        --   4-50
          -- chk_4_51  ddv           --   4-51

          -- Contacts:  

          -- chk_4_52  abbrev        --   4-52
          -- chk_4_53  emails        --   4-53
          -- chk_4_54  findContacts  --   4-54

          -- (Tree a):  

          -- chk_4_55  trees         --   4-55
          -- chk_4_56  nTrees        --   4-56
\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\section{ }

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{  << >>}

\textbf{4-1}  
\begin{center}
   \prg{inRng :: Int -> Int -> [Int] -> [Int]},
\end{center}
  \prg{inRng a b xs}   \prg{x}   \prg{xs}     (\prg{a <= x}  \prg{x <= b}), :
\begin{semicode}
main:> inRng 5 10 [1..15]
[5,6,7,8,9,10]

main:> inRng 1 0 [-5 .. 5]
[]
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-2}   \prg{upAlpha :: String -> String},             , :
\begin{semicode}
main:> upAlpha "Hello, World!"
"HELLOWORLD"

main:> upAlpha "Hi."
"HI"
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-3}   \prg{sumDigits :: String -> Int},     , :
\begin{semicode}
main:> sumDigits "CA 90210"
12

main:> sumDigits "No digits here!"
0
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-4}   \prg{idxs :: Eq a => [a] -> a -> [Int]},       ,  \prg{(==)} ,   ,    , :
\begin{semicode}
main:> idxs "Bookshop" 'o'
[1,2,6]

main:> idxs "senselessness's" 's'
[0,3,7,8,11,12,14]
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-5}   \prg{delGt:: Ord a => a -> [a] -> [a]},       ,  .

 :
\begin{code}

\end{code}

\textbf{4-6}   \prg{remdumps :: Eq a => [a] -> [a]},        ,  \prg{foldl}  \prg{foldr}:
\begin{semicode}
main:> remdumps [1,2,2,3,3,3,1,1]
[1,2,3,1]
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-7}   \prg{chkDups :: Eq a => [a] -> Bool},  \prg{True},   ,   ,      .
\begin{semicode}
main:> chkDups [1,2,3,4,5]
False

main:> chkDups [1,2,3,2]
True
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-8}   \prg{sumSq :: Int -> Int},       \prg{1}  \prg{n}.

 :
\begin{code}

\end{code}

\textbf{4-9}   \prg{isSorted :: Ord a => [a] -> Bool},  \prg{True},   ~---  , \prg{True}~--- .

 :
\begin{code}

\end{code}

\textbf{4-10}    \prg{ys},    .   \prg{insWord :: String -> [String]  -> [String]}    \prg{x}   \prg{ys}
\begin{center}
   \prg{zs = insWord x ys}
\end{center}
  ,  ,  \prg{x}  \prg{ys}  (  ,  \prg{x}    \prg{ys}).

 :
\begin{code}

\end{code}

\textbf{4-11}    \emph{ys},    .    \prg{insWords :: [String] -> [String] -> [String]}, 
\begin{center}
   \prg{insWords} \emph{xs} \emph{ys} \prg{->} \emph{zs}
\end{center}
  \emph{x}  \emph{xs}   \emph{ys},      4-10. 

 :
\begin{code}

\end{code}

\textbf{4-12}   \prg{substrings :: String -> [String]},         () .

 :
\begin{code}

\end{code}

\textbf{4-13}    $e$   
\[
 e = \sum_{n=0}^\infty \frac{1}{n!}
\]
  \prg{eApr :: Float -> Float},   $e$    $\epsilon$:
\begin{center}
   \prg{eApr} $\epsilon$ \prg{->} $e'$
\end{center}
 $e'\approx {e}$   $\epsilon$.

\textbf{:}    ,    $\epsilon$.

 :
\begin{code}

\end{code}

\textbf{4-14}   \prg{pairs :: Int -> [(Int, Int)]},   \prg{pairs $n$}     $(x, y)$, ,  $1 \leq x \leq n$, $1 \leq y \leq n$.

 :
\begin{code}

\end{code}

\textbf{4-15}   
\begin{center}
   \prg{qs :: Integer -> [(Integer,Integer,Integer,Integer)]}
\end{center}
  
\begin{center}
   \prg{[...$(a,b,c,d)$...] = qs $n$}
\end{center}
   $(a, b, c, d)$,    $(a, b, c, d)$  , $a^2 + b^2 = c^2 + d^2$   
$1 \leq a < c  \leq d < b \leq n$.


 :
\begin{code}

\end{code}

\textbf{4-16}   \prg{[Float]}   $x_1 \leq x_2 \leq \dots \leq x_n$     $y$.   \prg{fsearch :: [Float] -> Float -> Int},   $k$,  $x_k < y \leq x_{k+1}$.

\textbf{ }.
 $y \leq x_1$,    \prg{0}.
 $x_n < y$,    $n$.

 : 
\begin{code}

\end{code}

\textbf{4-17}   $a \geq 0$    $d$   $\sqrt{a}$    ,       ,    $\sqrt{a}$:
\begin{itemize}
	\item $x_1 = \frac {(a + 1)}{2}$;
	\item $x_{n+1} = \frac{1}{2}(x_n + \frac{a}{x_n})$;
	\item   $|x_{n+1} - x_n| \leq d$,    $x_{n+1}$~---    .	
\end{itemize}
  \prg{sqrtH :: Float -> Float -> Float},     $a$  $d$   $\sqrt {a}$.

 :
\begin{code}

\end{code}

\textbf{4-18}   ,     ,    ,     . , \prg{[1,2,1]}   \prg{[2,1,1]}.  
\begin{center}
   \prg{isPermutation :: Eq a => [a] -> [a] -> Bool},
\end{center}
 \prg{True},        .

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%

\subsection{  }

 Unix shell  , ,  : \prg{*.hs},       .

    $p$   $s$ :
\begin{itemize}
 \item       ;
 \item   \prg{'*'}    (  )  ;
 \item         ;
 \item   $p'$  o  $s'$,   $p''$  o  $s''$,   $p'\,p''$  o  $s'\,s''$.
\end{itemize}

\textbf{4-19}   \prg{pmatch :: String -> String -> Bool},   \prg{pmatch p s},    \prg{p}   \prg{s}.

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{ << >>}

 << >>   .      (1, 2, 3).   1    \prg{n} ;      ,      ( )  .

      $i \in \{1, 2, 3\}$            $j \in \{1, 2, 3\}$.         (     $j$  ),     ,        $j$.

    \prg{($i$, $j$) :: (Int, Int)},         .

\textbf{ .}           1   3.

\textbf{ .}     .      $n$    1   3 (   2) :
\begin{itemize}
	\item    $(n-1)$    1   2,     3;
	\item         1   3;
	\item     $(n-1)$    2   3,    1;
\end{itemize}

\textbf{4-20}   \prg{hanoiSteps :: Int -> [(Int, Int)]},   ,   ,      $n$~---  $n$   1-   3-.

 :
\begin{code}

\end{code}

\textbf{4-21}   \prg{hanoiNum :: Integer -> Integer},   ,   ,      $n$~---  $n$   1-   3-.

\textbf{:}  \prg{hanoiNum}      $n$.  ,    \prg{hanoiNum}    \prg{hanoiSteps} (  <<  ,    >>),     (, -  ).

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{Poly}:    }

     \prg{Poly}   ~\ref{s:pol-x} ( \prg{Types2}).

\textbf{4-22}   \prg{eqPP :: Poly -> Poly -> Bool},     .

 :
\begin{code}

\end{code}

\textbf{4-23}   \prg{addPP :: Poly -> Poly -> Poly},   .

 :
\begin{code}

\end{code}

\textbf{4-24}   \prg{subPP :: Poly -> Poly -> Poly},     ()  ().

 :
\begin{code}

\end{code}

\textbf{4-25}   \prg{mulPP :: Poly -> Poly -> Poly},   .

 :
\begin{code}

\end{code}

\textbf{4-26}   \prg{divModPP :: Poly -> Poly -> (Poly, Poly)}       .

 $A$, $B$  , \prg{divModPP $A$ $B$ -> ($Q$, $R$)},  $(a, b, q, r)$~---   $(A, B, Q, R)$.     $A = Q \times B + R$  $r < b$.

 :
\begin{code}

\end{code}

\textbf{4-27}   \prg{valPX :: Poly -> Float -> Float},   \prg{valPX p x}  \prg{p}    \prg{x}.

 :
\begin{code}

\end{code}

\textbf{4-28}   \prg{mulCP :: Float -> Poly -> Poly},   \prg{mulCP c p}  \prg{p}   \prg{c}.

 :
\begin{code}

\end{code}

\textbf{4-29}   \prg{povPN :: Poly -> Int -> Poly},   \prg{$p'$ = povPN $p$ $n$}   $p$   $n \geq 0$.

 :
\begin{code}

\end{code}

\textbf{4-30}   \prg{dPdX :: Poly -> Poly},   .

 :
\begin{code}

\end{code}

\textbf{4-31}   \prg{dNPdXN :: Poly -> Int -> Poly},   \prg{dNPdXN p $n$}   $n \geq 0$   \prg{p}.

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{Poly'}:      ~--- << >>}

       <<>> ~---  , ,      ,     ,   : ~---    , ~---    .

\textbf{4-32}   \prg {sim'P :: Poly' -> Poly'},   (.  ).

 :
\begin{code}

\end{code}

\textbf{4-33}   \prg{eq'PP :: Poly' -> Poly' -> Bool},     .

 :
\begin{code}

\end{code}

\textbf{4-34}   \prg{add'PP :: Poly' -> Poly' -> Poly'},   .    \prg{add'PP}     .

 :
\begin{code}

\end{code}

\textbf{4-35}   \prg{sub'PP :: Poly' -> Poly' -> Poly'},     (),  ().    \prg{sub'PP}     .

 :
\begin{code}

\end{code}

\textbf{4-36}   \prg{mul'PP :: Poly' -> Poly' -> Poly'},   .     \prg{mul'PP}     .

 :
\begin{code}

\end{code}

\textbf{4-37}  
\begin{center}
  \prg{divMod'PP :: Poly' -> Poly' -> (Poly', Poly')} 
\end{center}
      .

 :
\begin{code}

\end{code}

\textbf{4-38}   \prg{val'PX :: Poly' -> Float -> Float},   \prg{$y$ = val'PX $P$ $x$}  $P$    $x$.

 :
\begin{code}

\end{code}

\textbf{4-39}   \prg{mul'CP :: Float -> Poly' -> Poly'},     .

 :
\begin{code}

\end{code}

\textbf{4-40}   \prg{pov'PN :: Poly' -> Int -> Poly'},   \prg{$p'$ = pov'PN $p$ $n$}   $p$   $n \geq 0$.

 :
\begin{code}

\end{code}

\textbf{4-41}  
\begin{center}
 \prg{dP'dX :: Poly' -> Poly'},
\end{center}
  .

 :
\begin{code}

\end{code}

\textbf{4-42}   \prg{dNP'dXN :: Poly' -> Int -> Poly'},      .

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{Point2D}:    }

\textbf{4-43}  
\begin{center}
\prg{dist2D :: Point2D -> Point2D -> Float},
\end{center}
    $\rho(A(x_1,y_1), B(x_2,y_2))$.

 :
\begin{code}

\end{code}

\textbf{4-44}  
\begin{center}
   \prg{dist2Ds :: Point2D -> [Point2D] -> [Float]},
\end{center}
       ,   .

 :
\begin{code}

\end{code}

\textbf{4-45}  ,        :
\begin{center}
\prg{minDist2Ds :: [Point2D] -> Float}\\
\prg{minDist2Ds [$p_1, \ldots p_n$] 
     = $min\{\rho(p_i,p_j)\,|\, 1 \leq i<j \leq n\}$
    }
\end{center}

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{Prop}:   }

\textbf{4-46}   \prg{vars :: Prop -> [String]},        ( ).

 :
\begin{code}

\end{code}

\textbf{4-47}              .        <<~--- >>, : \prg{[("p"{},  True), ("q"{}, False)]}.

  \prg{evalPV :: Prop -> [(String,Bool)] -> Bool},  ,       .

 :
\begin{code}

\end{code}

\textbf{4-48}   \prg{tauto :: Prop -> Bool},
   \prg{True},       ,   \prg{False}   .

 :
\begin{code}

\end{code}

\textbf{4-49}   \prg{contra :: Prop -> Bool},
   \prg{True},       ,   \prg{False}   .

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{Expr}:  }

\textbf{4-50}            .        <<~--- >>, : \prg{[("p"{}, -1.7), ("q"{}, 3.14)] :: [(String,Float)]}.

 
\begin{center}
  \prg{evalEV :: Expr -> [(String,Float)] -> Float},
\end{center}
        .

 :
\begin{code}

\end{code}

\textbf{4-51}   \prg{ddv :: Expr -> String -> Expr}  ,      ,    .

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{Contacts}:  }

\textbf{4-52}           <<>>, << >>, <<  >>.   \prg{abbrev :: [String] -> [String]},      , :
\begin{semicode}
   xs = ["", "  ", " "]
\end{semicode}
      :
\begin{semicode}
   abbrev xs = ["", ". . ", ". "]
\end{semicode}

 :
\begin{code}

\end{code}

\textbf{4-53}   \prg{emails :: Contacts -> [Email]},       ( )   .

 :
\begin{code}

\end{code}

\textbf{4-54}  
\begin{center}
   \prg{findContacts :: Contacts -> Name -> [(Phone, Email)]},
\end{center}
            .

 :
\begin{code}

\end{code}

%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%\%
\subsection{\prg{(Tree a)}:  }

\textbf{4-55}  \prg{a}  ,  \prg{Ord a}, \prg{xs :: [a]}       .   \prg{trees :: Ord a => [a] -> [(Tree a)]},    \prg{xs}       \prg{t}, ,  \prg{xs == flatten t}.

 :
\begin{code}

\end{code}

\textbf{4-56}   \prg{nTrees :: Int -> Integer},     \prg{n}       \prg{t}, ,  \prg{[1..n] == flatten t}.

\textbf{:}  \prg{nTrees}      \prg{n}.      \prg{nTrees}    \prg{trees} (,   \prg{length (trees [1..n])}),     (-   :    ).

 :
\begin{code}

\end{code}

\end{document}